% Fhrer/Heidemann/Nerreter, Band 2
% Kapitel 2, Beispiel 1
disp('Fhrer/Heidemann/Nerreter');
disp('Grundgebiete der Elektrotechnik, Band 2');
disp('Beispiel 2.1');
disp(' ');
clc;
figure;
gu=0; % untere Grenze
go=60; % obere Grenze
n=100;
x=[0 10 20 30 40 50 60]; % Werte der Spannung U in Volt
y=[100 80 67.8 59.0 51.9 46.2 41.7]; % Werte der Kapazitt C in nF
anzahl=n*length(x)-1;
s=(go-gu)/anzahl; % Schrittweite
xx=gu:s:go; % Werte U
yy=spline(x,y,xx); % Werte C
plot(xx,yy); hold on; grid;
Q=[0 800 20*67.8 30*59.0 40*51.9 50*46.2 60*41.7];
Qs=spline(x,Q,xx);
cc=diff(Qs);
fact=100/cc(1);
cs=fact*cc;
cs(length(xx))=cs(length(xx)-1);
cs=spline(xx,cs,xx); % Werte der differenziellen Kapazitt c in nF
plot(xx,cs,'r');
xlabel('U in V'); ylabel('nF');
% figure; plot(xx,Qs); grid;
W=0;
for k=2:anzahl;
    W=W+xx(k)*cs(k)*(xx(k)-xx(k-1));
end;
disp(' U in V    C in nF      c in nF');
for k=1:length(x);
    xd=x(k);
    disp(['   ',sprintf(' %3d ',x(k)),'     ',sprintf(' %3.1f ',y(k)),'    ',sprintf(' %3.2f ',spline(xx,cs,xd))]);
end;
disp(' ');
disp(['W =',sprintf(' %2.4f ',W*1.0e-3),'uJ']);